<?php

namespace AfterSalesProGr\AcsPoints\Controller\Adminhtml\UpdatePoints;

use Magento\Framework\Exception\LocalizedException;
use Magento\Framework\View\Result\PageFactory;

class Index extends \Magento\Backend\App\Action
{
    /**
     * @var PageFactory
     */
    protected $resultPageFactory;

    protected $helper;
    protected $jsonHelper;

    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory,
        \Magento\Framework\Json\Helper\Data $jsonHelper,
        \AfterSalesProGr\AcsPoints\Helper\Data $helper
    ) {
        $this->helper = $helper;
        $this->resultPageFactory = $resultPageFactory;
        $this->jsonHelper = $jsonHelper;
        parent::__construct($context);
    }

    public function execute()
    {
        $response = [
            'message' => 'Points generated!'
        ];
        try {
            $points = $this->helper->updatePoints();
            if (empty($points)){
                $response['message'] = 'No points found!';
            }
            return $this->jsonResponse($response);
        } catch (LocalizedException $e) {
            $response['message'] = $e->getMessage();
            return $this->jsonResponse($response);
        } catch (\Exception $e) {
            $response['message'] = $e->getMessage();
            return $this->jsonResponse($response);
        }
    }

    /**
     * Create json response
     *
     * @return \Magento\Framework\Controller\ResultInterface
     */
    public function jsonResponse($response = '')
    {
        return $this->getResponse()->representJson(
            $this->jsonHelper->jsonEncode($response)
        );
    }
}
